<p align="center">
    <a href="https://sylius.com" target="_blank">
        <img src="https://demo.sylius.com/assets/shop/img/logo.png" />
    </a>
</p>

<h1 align="center">Plugin Dedi Sogenactif</h1>

## Documentation

This plugin handle payment with Sogénactif through `Payum` the solution of the company Société Général. 
 
## Test card
 
Example : if you use this card `4100 00 00 0000 00 05` , it is a VISA and the payment will be refused (response code `05` ).

Details about card number:

Card number (PAN) has between 15 and 19 numbers (depends of the type of card) ;

* VISA 4100 00
* CB 4200 00

Response code is calculated with the two last numbers:

* all is right: 00
* technical problem : 90, 99,
* threat : 34,
* too much try : 75,
* stop / go away of the app : 97.

Security code of card (CVV) have 3 to 4 numbers. This value is not important on the sandbox during manual testing.
 
## Quickstart Installation

```bash
$ make start
$ make db-create
$ make db-update
$ make fixtures

$ make build
```

## Usage

### Environment

This plugin work actually with open test api and transactions are creating on Sogénactif API sandbox for purpose test:

- `FQDN_URL_INITIALIZE_TRANSACTION`: https://payment-webinit.simu.sogenactif.com/rs-services/v2/paymentInit 

### Running plugin tests

  - PHPUnit

    ```bash
    $ vendor/bin/phpunit
    ```

  - PHPSpec

    ```bash
    $ vendor/bin/phpspec run
    ```

  - Behat (non-JS scenarios)

    ```bash
    $ vendor/bin/behat --tags="~@javascript"
    ```

  - Behat (JS scenarios)
 
    1. Download [Chromedriver](https://sites.google.com/a/chromium.org/chromedriver/)
    
    2. Download [Selenium Standalone Server](https://www.seleniumhq.org/download/).
    
    2. Run Selenium server with previously downloaded Chromedriver:
    
        ```bash
        $ java -Dwebdriver.chrome.driver=chromedriver -jar selenium-server-standalone.jar
        ```
        
    3. Run test application's webserver on `localhost:8080`:
    
        ```bash
        $ (cd tests/Application && bin/console server:run localhost:8080 -d public -e test)
        ```
    
    4. Run Behat:
    
        ```bash
        $ vendor/bin/behat --tags="@javascript"
        ```

### Opening Sylius with your plugin

- Using `test` environment:

    ```bash
    $ (cd tests/Application && bin/console sylius:fixtures:load -e test)
    $ (cd tests/Application && bin/console server:run -d public -e test)
    ```
    
- Using `dev` environment:

    ```bash
    $ (cd tests/Application && bin/console sylius:fixtures:load -e dev)
    $ (cd tests/Application && bin/console server:run -d public -e dev)
    ```


A phpspec watcher is installed. See configuration in `.phpspec-watcher.yml`. You can start it with :

```
$ make phpspec-watch
```

#### About Sogenatcif creation

- [Creation workflow](docs/paiement-sogenactif.md)
